from z3 import *
set_param(proof=True)
try:
	CONRT_EtherStore= DeclareSort('CONRT_EtherStore')
	map= DeclareSort('map')
	EtherStore_balances= Function('EtherStore_balances',CONRT_EtherStore,map)
	total= Int('total')
	address= DeclareSort('address')
	msg_sender= Const('msg_sender',address)
	d1FaddressTuint256mapping= Function('d1FaddressTuint256mapping',map,address,IntSort())
	bal= Int('bal')
	void= DeclareSort('void')
	_1solidity= Const('_1solidity',void)
	sent= Const('sent',BoolSort())
	_2solidity= Const('_2solidity',void)
	string= DeclareSort('string')
	error= Const('error',string)
	TUPLE= DeclareSort('TUPLE')
	TUPLE_0= Const('TUPLE_0',TUPLE)
	LOW_LEVEL_CALL_call= Function('LOW_LEVEL_CALL_call',address,IntSort(),TUPLE)
	UNPACK2DTUPLETbool= Function('UNPACK2DTUPLETbool',TUPLE,IntSort(),BoolSort())
	lv_1var= Const('lv_1var',BoolSort())
	lv_2var= Const('lv_2var',BoolSort())
	_5reentrancy_verifier= Int('_5reentrancy_verifier')
	_6reentrancy_verifier= Int('_6reentrancy_verifier')
	IsEtherStore= Function('IsEtherStore',CONRT_EtherStore,BoolSort())
	EtherStore_balances1= Function('EtherStore_balances1',CONRT_EtherStore,map)
	error1= Const('error1',string)
	bal1= Int('bal1')
	TUPLE_01= Const('TUPLE_01',TUPLE)
	msg_sender1= Const('msg_sender1',address)
	LOW_LEVEL_CALL_call1= Function('LOW_LEVEL_CALL_call1',address,IntSort(),TUPLE)
	sent1= Const('sent1',BoolSort())
	UNPACK2DTUPLETbool1= Function('UNPACK2DTUPLETbool1',TUPLE,IntSort(),BoolSort())
	lv_1var1= Const('lv_1var1',BoolSort())
	total1= Int('total1')
	d1FaddressTuint256mapping1= Function('d1FaddressTuint256mapping1',map,address,IntSort())
	_1solidity1= Const('_1solidity1',void)
	_2solidity1= Const('_2solidity1',void)
	lv_2var1= Const('lv_2var1',BoolSort())
	_5reentrancy_verifier1= Int('_5reentrancy_verifier1')
	_6reentrancy_verifier1= Int('_6reentrancy_verifier1')
	_y21= Const('_y21',CONRT_EtherStore)
	_y22= Const('_y22',address)
	_y23= Int('_y23')
	_y24= Const('_y24',TUPLE)
	_y25= Int('_y25')
	_y26= Const('_y26',CONRT_EtherStore)
	_y27= Const('_y27',map)
	_y28= Const('_y28',address)
	_y29= Const('_y29',CONRT_EtherStore)
	_y30= Const('_y30',CONRT_EtherStore)
	_y31= Const('_y31',CONRT_EtherStore)
	_y32= Const('_y32',CONRT_EtherStore)
	_y33= Const('_y33',CONRT_EtherStore)
	_y34= Const('_y34',CONRT_EtherStore)
	_y35= Const('_y35',CONRT_EtherStore)
	_y36= Const('_y36',CONRT_EtherStore)
	_y37= Const('_y37',CONRT_EtherStore)
	_y38= Const('_y38',CONRT_EtherStore)
	_s=Solver()
	_s.set("timeout",50000)
	_s.add(ForAll([_y21],EtherStore_balances1(_y21)==EtherStore_balances(_y21)))
	_s.add(_1solidity1==_1solidity)
	_s.add(_2solidity1==_2solidity)
	_s.add(ForAll([_y22,_y23],LOW_LEVEL_CALL_call1(_y22,_y23)==LOW_LEVEL_CALL_call(_y22,_y23)))
	_s.add(ForAll([_y24,_y25],UNPACK2DTUPLETbool1(_y24,_y25)==UNPACK2DTUPLETbool(_y24,_y25)))
	_s.add(ForAll([_y26,msg_sender],total1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),If(And(((EtherStore_balances(_y26))==(EtherStore_balances(_y26))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender))),0),((If(((total <= 100)==(True)),If(((If(And(((EtherStore_balances(_y26))==(EtherStore_balances(_y26))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender)))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y26))==(EtherStore_balances(_y26))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender))),0),total + 2,total),total),total + 1))+(2)),If(((total <= 100)==(True)),If(((If(And(((EtherStore_balances(_y26))==(EtherStore_balances(_y26))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender)))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y26))==(EtherStore_balances(_y26))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender))),0),total + 2,total),total),total + 1)),total),total + 1)))
	_s.add(ForAll([_y27,_y28,_y29,msg_sender],d1FaddressTuint256mapping1(_y27,_y28)==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y29),msg_sender))>(0)),If(((total <= 100)==(True)),If(((If(And(((EtherStore_balances(_y29))==(EtherStore_balances(_y29))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y29),msg_sender)))>(0)),If(And(((_y27)==(EtherStore_balances(_y29))),((_y28)==(msg_sender))),0,If(And(((_y27)==(EtherStore_balances(_y29))),((_y28)==(msg_sender))),0,d1FaddressTuint256mapping(_y27,_y28))),If(And(((_y27)==(EtherStore_balances(_y29))),((_y28)==(msg_sender))),0,d1FaddressTuint256mapping(_y27,_y28))),If(And(((_y27)==(EtherStore_balances(_y29))),((_y28)==(msg_sender))),0,d1FaddressTuint256mapping(_y27,_y28))),d1FaddressTuint256mapping(_y27,_y28)),d1FaddressTuint256mapping(_y27,_y28))))
	_s.add(ForAll([_y30,msg_sender],bal1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y30),msg_sender))>(0)),If(((total <= 100)==(True)),If(And(((EtherStore_balances(_y30))==(EtherStore_balances(_y30))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y30),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y30),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y30),msg_sender)),bal)))
	_s.add(ForAll([_y31,msg_sender],sent1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y31),msg_sender))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),If(And(((EtherStore_balances(_y31))==(EtherStore_balances(_y31))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y31),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y31),msg_sender))),0),sent),sent)))
	_s.add(ForAll([_y33,msg_sender],TUPLE_01==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y33),msg_sender))>(0)),LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),If(And(((EtherStore_balances(_y33))==(EtherStore_balances(_y33))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y33),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y33),msg_sender))),TUPLE_0),TUPLE_0)))
	_s.add(ForAll([_y34,msg_sender],lv_1var1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y34),msg_sender))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),If(And(((EtherStore_balances(_y34))==(EtherStore_balances(_y34))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y34),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y34),msg_sender))),0),lv_1var),lv_1var)))
	_s.add(ForAll([_y35,msg_sender],lv_2var1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y35),msg_sender))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),If(And(((EtherStore_balances(_y35))==(EtherStore_balances(_y35))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y35),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y35),msg_sender))),0),lv_2var),lv_2var)))
	_s.add(ForAll([_y36,msg_sender],_5reentrancy_verifier1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y36),msg_sender))>(0)),1,0),0)))
	_s.add(ForAll([_y37,msg_sender],_6reentrancy_verifier1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y37),msg_sender))>(0)),If(((total <= 100)==(True)),If(((If(And(((EtherStore_balances(_y37))==(EtherStore_balances(_y37))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y37),msg_sender)))>(0)),1,0),0),0),0)))
	_s.add(ForAll([_y38,msg_sender],And(((total <= 100)==(True)),((d1FaddressTuint256mapping(EtherStore_balances(_y38),msg_sender))>(0)))))
	_s.add(Not(And((_5reentrancy_verifier1==1),(_6reentrancy_verifier1==0))))
except Exception as e:
	print("Error1(Z3Query)"+str(e))
	sys.exit(1)
try:
	result=_s.check()
	if sat==result:
		print("Counter Example")
		print (_s.model())
	elif unsat==result:
		print ("Successfully Proved")
	else:
		print("Failed To Prove")
except Exception as e:
	print("Error2(Z3Query)"+str(e))
	sys.exit(1)